<i18n>
{
  "fr": {
    "title": "Les scénarios",
    "title-2": "Supprimer le scénario",
    "info-1": "TODO",
    "info-2": "Aucun scénario",
    "info-3": "Êtes vous sûr de vouloir supprimer le scénario",
    "field-1": "Nom",
    "field-2": "Variables",
    "tooltip-1": "Charger le scénario",
    "tooltip-2": "Supprimer le scénario",
    "tooltip-3": "Charger le lien publique du scénario"
  },
  "en": {
    "title": "The scenarios",
    "title-2": "Delete scenario",
    "info-1": "TODO",
    "info-2": "No scenario",
    "info-3": "Are you sure that you want to delete the scenario",
    "field-1": "Name",
    "field-2": "Variables",
    "tooltip-1": "Load the scenario",
    "tooltip-2": "Delete the scenario",
    "tooltip-3": "Load the scenario public link"
  }
}
</i18n>

<template>
  <div>
    <su-service :icon="'crosshairs'">
      <template #title>
        {{ $t('title') }}
      </template>
      {{ $t('info-1') }}
    </su-service>
    <br />
    <b-table
      :data="scenarios"
      :striped="true"
      :narrowed="true"
      :hoverable="true"
    >
      <b-table-column :label="$t('field-1')" sticky v-slot="props">
        {{ props.row.name }}
      </b-table-column>
      <b-table-column :label="$t('field-2')" v-slot="props">
        <b-taglist>
          <b-tag
            v-for="(variable,index) in props.row.variables"
            :key="index"
          >
            {{ variable.name }}
          </b-tag>
        </b-taglist>
      </b-table-column>
      <b-table-column v-slot="props">
        <div class="panel-block">
          <b-tooltip
            :label="$t('tooltip-1')"
            type="is-black"
          >
            <b-button
              size="is-small"
              type="is-primary"
              icon-left="cloud-download"
              @click="loadScenario(props.row.uuid)"
            />
          </b-tooltip>
          <b-tooltip
            :label="$t('tooltip-3')"
            type="is-black"
            position="is-left"
          >
            <b-button
              size="is-small"
              icon-left="external-link"
              @click="copyLink(props.row.id)"
            />
          </b-tooltip>
          <b-tooltip
            :label="$t('tooltip-2')"
            type="is-black"
          >
            <b-button
              size="is-small"
              icon-right="trash"
              @click="deleteScenario(props.row)"
            />
          </b-tooltip>
        </div>
      </b-table-column>
      <section slot="empty" class="section">
        <div class="content has-text-grey has-text-centered">
          <p>
            <i class="sui sui-ban" style="font-size: 64px;"></i>
          </p>
          <p>{{ $t('info-2') }}</p>
        </div>
      </section>
    </b-table>
    <br />
    <nav class="level">
      <div class="level-left"></div>
      <div class="level-right">
        <div class="buttons">
          <b-button
            class="button"
            icon-left="plus"
            @click="createScenario()"
          >
            {{ $t('add') }}
          </b-button>
        </div>
      </div>
    </nav>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  name: 'AllScenarios',
  components: {
    'su-service': () => import('@/components/SUService.vue')
  },
  methods: {
    createScenario () {
      this.$router.push('/scenario-1point5/')
    },
    loadScenario (uuid) {
      this.$router.push('/scenario-1point5/' + uuid)
    },
    copyLink (id) {
      let scenario = this.scenarios.find(obj => obj.id === id)
      let route = this.$router.resolve({ path: '/scenario-1point5/' + scenario.uuid })
      window.open(route.href, '_blank')
    },
    deleteScenario (scenario) {
      let self = this
      this.$buefy.dialog.confirm({
        title: self.$t('title-2') + ' ' + scenario.name,
        message: self.$t('info-3') + ' <b> ' + scenario.name + '</b> ?',
        confirmText: self.$t('validate'),
        cancelText: self.$t('cancel'),
        canCancel: ['escape', 'button', 'outside'],
        onConfirm: function () {
          const loadingComponent = self.$buefy.loading.open({
            container: null
          })
          self.$store.dispatch('admin/deleteScenario', scenario.id)
            .then(data => {
              loadingComponent.close()
            })
            .catch((erreur) => {
              loadingComponent.close()
            })
        }
      })
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    scenarios: function () {
      return this.$store.getters['admin/allScenarios']
    }
  },
  mounted () {
    if (this.isAuthenticated) {
      const loadingComponent = this.$buefy.loading.open({
        container: null
      })
      this.$store.dispatch('admin/getScenarios')
        .then(data => {
          loadingComponent.close()
        })
        .catch((erreur) => {
          loadingComponent.close()
        })
    }
  }
}
</script>

<style>
.is-sticky {
  background: #fafafa !important;
}
.table td {
  vertical-align: middle !important;
}
.table th {
  vertical-align: middle !important;
}
</style>
